#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "spasm.h"

struct spasmConfigStruct *spasm_config;

void spasm_error(int syslevel, char *errstr, ...) {
    va_list arglist;

    va_start(arglist, errstr);
    vfprintf(stderr, errstr, arglist);
    fprintf(stderr, "\n");      /* spasm_error args aren't terminated by \n */
    va_end(arglist);
}

int main(int argc, char **argv) {
    char *stats, *value;
    int connect = 0;
    int global_ip_bl = 0;
    int verifymx = 0;
    int rejected = 0;
    int global_wl_helo = 0;
    int greylist = 0;
    int virus = 0;
    int rcpt = 0;
    int messages = 0;
    int i;

    if(argc < 2) {
	fprintf(stderr, "syntax: %s <statsfile> [statsfile2...]\n", argv[0]);
	exit(1);
    }

    if((spasm_config = spasm_cfg()) == NULL) {
	exit(1);
    }

    for(i=1; i<argc; i++) {
	stats = argv[i];
	if((value = qdbm_lookup_entry(stats, "connect")) != NULL) { connect += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "global_ip_bl")) != NULL) { global_ip_bl += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "verifymx")) != NULL) { verifymx += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "rejected")) != NULL) { rejected += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "global_wl_helo")) != NULL) { global_wl_helo += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "greylist")) != NULL) { greylist += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "virus")) != NULL) { virus += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "rcpt")) != NULL) { rcpt += atoi(value); free(value); }
	if((value = qdbm_lookup_entry(stats, "messages")) != NULL) { messages += atoi(value); free(value); }
    }

    printf("Connection Statistics\n");
    printf("global_ip_bl: %d (connect)\n", global_ip_bl);
    printf("global_wl_helo: %d (helo)\n", global_wl_helo);
    printf("greylist: %d (envfrom)\n", greylist);
    printf("verifymx: %d (envfrom)\n", verifymx);
    printf("connections: %d (connect)\n", connect);
    printf("\n");
    printf("Recipient Statistics\n");
    printf("rcpt: %d (envrcpt)\n", rcpt);
    printf("\n");
    printf("Message Statistics\n");
    printf("rejected: %d (message)\n", rejected);
    printf("virus: %d (message)\n", virus);
    printf("messages: %d (envfrom)\n", messages);

    exit(0);
}
