/*
 * **    spasm - The spasm anti-spam milter
 * **    Copyright (C) 2002-2005 Sean Hanson <aradia@theasylum.org>
 * **
 * **    This program is free software; you can redistribute it and/or modify
 * **    it under the terms of the GNU General Public License as published by
 * **    the Free Software Foundation; either version 2 of the License, or
 * **    (at your option) any later version.
 * **
 * **    This program is distributed in the hope that it will be useful,
 * **    but WITHOUT ANY WARRANTY; without even the implied warranty of
 * **    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * **    GNU General Public License for more details.
 * **
 * **    You should have received a copy of the GNU General Public License
 * **    along with this program; if not, write to the Free Software
 * **    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#ifndef _EXTERN_H
#define _EXTERN_H

#include "depot.h"

#define SPASM_DBT_MAX 1024

struct spasm_list {
    char entry[SPASM_DBT_MAX+1];
    char strval[SPASM_DBT_MAX+1];
    int value;
    struct spasm_list *next;
};

#define USR_STRCAT(buf, username, dbfile) snprintf(buf, sizeof(buf), "%s/users/%s/%s", spasm_config->spasmroot, username, dbfile)
#define SYS_STRCAT(buf, dbfile) snprintf(buf, sizeof(buf), "%s/system/%s", spasm_config->spasmroot, dbfile)

char* qdbm_lookup_entry(char *dbfile, char *key);
void qdbm_insert_entry(char *dbfile, char *key, char *value);
void qdbm_delete_entry(char *dbfile, char *key);
struct spasm_list* qdbm_dump_entries(char *dbfile, int vals);

/* Database Abstraction Functions */
int spasm_verify_filters(char *username);
int spasm_lookup_filter(char *username, char *entry);
struct spasm_list* spasm_get_filters(char *username);
void spasm_set_filter(char *username, char *entry, int value);

int spasm_lookup_db(char *database, char *entry);
struct spasm_list* spasm_get_db(char *database);
void spasm_insert_db(char *database, char *entry, char *val);
void spasm_delete_db(char *database, char *entry);
int spasm_set_db(char *database, struct spasm_list *entries);

int spasm_lookup_bl(char *blacklist, char *entry);
struct spasm_list* spasm_get_bl(char *blacklist);
void spasm_insert_bl(char *blacklist, char *entry, char *val);
void spasm_delete_bl(char *blacklist, char *entry);
int spasm_set_bl(char *blacklist, struct spasm_list *entries);

int spasm_lookup_wl(char *whitelist, char *entry);
struct spasm_list* spasm_get_wl(char *whitelist);
void spasm_insert_wl(char *whitelist, char *entry, char *val);
void spasm_delete_wl(char *whitelist, char *entry);
int spasm_set_wl(char *whitelist, struct spasm_list *entries);

char* spasm_lookup_prefs(char *username, char *entry);
void spasm_del_prefs(char *username, char *entry);
void spasm_set_prefs(char *username, char *entry, char *value);

struct spasm_list* spasm_get_log(char *username, char *key, int all);
void spasm_insert_log(char *username, char *entry);
void spasm_delete_log(char *username, char *key, int all);

int spasm_lookup_gl(char *entry, char *value);
void spasm_insert_gl(char *entry, char *val);

int spasm_lookup_mx(char *entry, char *value);
void spasm_insert_mx(char *entry, char *value);

void spasm_update_stats(char *key);
/* End DB Abstraction Functions */

void spasm_create_user(char *username);

/* Internal Error Function */
#define USE_PRINTF 0
#define USE_SYSLOG 1
#define USE_CURSES 2
void spasm_error(int syslevel, char *errstr, ...);

#endif /* _EXTERN_H */
